﻿///////////////////////////////////////////////////////////////////////////////
// ROTATING CHARACTERS
///////////////////////////////////////////////////////////////////////////////
function RotChar (posX, parentDiv, offsetX, offsetY, charStr, height, width, size, cx, cy, bgColor, fgColor)
{
  var divElem = parentDiv.appendElement('<div enabled="false" background="' + bgColor + '" height="' + height + '" width="' + width + '" x="' + (offsetX + posX*(width+1)) + '" y="' + offsetY + '" />');
  this._labelElem = divElem.appendElement('<a enabled="false" font="courier new" size="' + size + '" x="' + cx + '" y="' + cy + '" color="' + fgColor + '" overcolor="' + fgColor + '" bold="true"> </a>');
  this._charStr = charStr;
}

RotChar.prototype._charStr;
RotChar.prototype._labelElem;
RotChar.prototype._intervalTimer;
RotChar.prototype._toChar;
RotChar.prototype._curChar = 0;

///////////////////////////////////////////////////////////////////////////////
RotChar.prototype.getLabelElem = function ()
{
  return this._labelElem;
}

///////////////////////////////////////////////////////////////////////////////
RotChar.prototype.setChar = function (char)
{
  this._toChar = this._charStr.indexOf (char);
  if (this._toChar == -1)
  {
    this._toChar = 0;
  }

  var self = this;
  clearInterval (this._intervalTimer);
  this._intervalTimer = setInterval (function () {self.rotateChar ();}, 100);
}

///////////////////////////////////////////////////////////////////////////////
RotChar.prototype.rotateChar = function ()
{
  if (this._toChar == this._curChar)
  {
    clearInterval (this._intervalTimer);
    return;
  }

  if (this._curChar >= this._charStr.length)
  {
    this._curChar = 0;
  }
  else
  {
    this._curChar++;
  }

  this._labelElem.innerText = this._charStr.charAt (this._curChar);
}

///////////////////////////////////////////////////////////////////////////////
// ROTATING CHARACTER ROWS
///////////////////////////////////////////////////////////////////////////////
function RotRow (chars, str, parentDiv, posX, posY, height, width, size, cx, cy, bgColor, fgColor)
{
  this._chars = chars;
  this._posX  = posX;
  this._posY  = posY;

  this._labelArr = new Array ();
  for (var x=0; x < this._chars; x++)
  {
    this._labelArr[x] = new RotChar (x, parentDiv, posX, posY, str, height, width, size, cx, cy, bgColor, fgColor);
  }
}

RotRow.prototype._chars;
RotRow.prototype._posX;
RotRow.prototype._posY;
RotRow.prototype._labelArr;

///////////////////////////////////////////////////////////////////////////////
RotRow.prototype.setStr = function (str)
{
  for (var x=0; x < this._chars; x++)
  {
    var ch = "";
    if (str != null)
    {
      if (String(str).charAt (x) != null)
      {
        ch = String(str).charAt (x);
      }
    }

    this._labelArr[x].setChar (ch.toUpperCase ());
  }
}


///////////////////////////////////////////////////////////////////////////////
// DATE TIME UTILITY
///////////////////////////////////////////////////////////////////////////////
function DTUtil (dateStr, id, dt)
{
  this._id = id;

  if ((dateStr != "") && (dateStr != null))
  {
    var str = dateStr.split ("-")[0];
    if ((str == null) || (str == "")) return;
    var year = parseInt (this.removeLeadingZero (str));

    str = dateStr.split ("-")[1];
    if ((str == null) || (str == "")) return;
    var month = parseInt (this.removeLeadingZero (str)) - 1;

    str = dateStr.split ("-")[2];
    if ((str == null) || (str == "")) return;
    str = str.split (" ")[0];
    if ((str == null) || (str == "")) return;
    var day   = parseInt (this.removeLeadingZero (str));

    str = dateStr.split (" ")[1];
    if ((str == null) || (str == "")) return;
    str = str.split (":")[0];
    if ((str == null) || (str == "")) return;
    var hours = parseInt (this.removeLeadingZero (str));

    str = dateStr.split (" ")[1];
    if ((str == null) || (str == "")) return;
    str = str.split (":")[1];
    if ((str == null) || (str == "")) return;
    var min   = parseInt (this.removeLeadingZero (str));
    
    this._date = new Date  ();
    this._date.setFullYear (year , month, day);
    this._date.setHours    (hours, min , 0, 0);
  }
  else if (dt != null)
  {
    this._date = dt;
  }
}

DTUtil.prototype._id;
DTUtil.prototype._date;
DTUtil.prototype._months = new Array (GADGET_JAN, GADGET_FEB, GADGET_MAR,
                                      GADGET_APR, GADGET_MAY, GADGET_JUN,
                                      GADGET_JUL, GADGET_AUG, GADGET_SEP,
                                      GADGET_OCT, GADGET_NOV, GADGET_DEC);

///////////////////////////////////////////////////////////////////////////////
DTUtil.prototype.removeLeadingZero = function (str)
{
  if (str.charAt (0) == "0")
  {
    return str.substr (1);
  }
  
  return str;
}

///////////////////////////////////////////////////////////////////////////////
DTUtil.prototype.getDT  = function ()
{
  return this._date;
}

///////////////////////////////////////////////////////////////////////////////
DTUtil.prototype.toString = function ()
{
  return "DTUtil: _id=" + this._id + ", _date=" + this._date;
}

///////////////////////////////////////////////////////////////////////////////
DTUtil.prototype.getTime = function ()
{
  if (this._date != null)
  {
    return this._date.getTime ();
  }
  
  return null;
}

///////////////////////////////////////////////////////////////////////////////
DTUtil.prototype.getFormattedYear = function ()
{
  if (this._date == null)
  {
    return "";
  }

  return this._date.getFullYear ();
}

///////////////////////////////////////////////////////////////////////////////
DTUtil.prototype.getFormattedMonth = function ()
{
  if (this._date == null)
  {
    return "";
  }

  return this._months[this._date.getMonth ()];
}

///////////////////////////////////////////////////////////////////////////////
DTUtil.prototype.getFormattedDay = function ()
{
  if (this._date == null)
  {
    return "";
  }

  var day = this._date.getDate ();
  if (day < 10)
  {
    return "0" + day;
  }

  return day;
}

///////////////////////////////////////////////////////////////////////////////
DTUtil.prototype.getFormattedHour = function ()
{
  if (this._date == null)
  {
    return "";
  }

  var hour = this._date.getHours ();
  if (hour < 10)
  {
    return "0" + hour;
  }

  return hour;
}

///////////////////////////////////////////////////////////////////////////////
DTUtil.prototype.getFormattedMin = function ()
{
  if (this._date == null)
  {
    return "";
  }

  var mins = this._date.getMinutes ();
  if (mins < 10)
  {
    return "0" + mins;
  }

  return mins;
}

///////////////////////////////////////////////////////////////////////////////
// FLIGHT INFORMATION
///////////////////////////////////////////////////////////////////////////////
function FlightInfo ()
{
  this._newInfo = new Array ();
  this._oldInfo = new Array ();

  this._newDT   = new Array ();
  this._oldDT   = new Array ();
}
   
FlightInfo.prototype._newInfo;
FlightInfo.prototype._oldInfo;

FlightInfo.prototype._newDT;
FlightInfo.prototype._oldDT;

FlightInfo.prototype._flightDepartureDT;
FlightInfo.prototype._flightArrivalDT;

FlightInfo.prototype._scheduledDepartureDT;
FlightInfo.prototype._scheduledArrivalDT;

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.update = function (responseXml)
{
  this._oldInfo = this._newInfo;
  this._newInfo = null;
  this._newInfo = new Array ();

  this._oldDT   = this._newDT;
  this._newDT   = null;
  this._newDT   = new Array ();

  this._newInfo["ac"]  = options.getValue ("airlineCode");
  this._newInfo["fn"]  = options.getValue ("flightNumber");
  this._newInfo["sga"] = options.getValue ("flightDate");
  this._newInfo["sgd"] = options.getValue ("flightDate");
  this._newInfo["dac"] = options.getValue ("airportCode");
   
  var messageNode = responseXml.getElementsByTagName ("message");
  if ((messageNode != null) && (messageNode.item (0) != null))
  {
    var messageItem = messageNode.item (0);
    this._newInfo["message"] = messageItem.getAttribute ("description");
    debug.trace ("update message:" + this._newInfo["message"]);
  }
  
  var fhNode = responseXml.getElementsByTagName ("fh");
  if ((fhNode != null) && (fhNode.item (0) != null))
  {
    var fhItem = fhNode.item (0);
    for (var index = 0; index < fhItem.attributes.length; index++)
    {
      var name  = fhItem.attributes[index].nodeName;
      var value = fhItem.attributes[index].nodeValue;
      
      if (value == null)
      {
        value = "";
      }
      
      debug.trace (name + " = " + value);
      this._newInfo[name] = value;
    }
  }
  
  this.updateDT ();
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.updateDT = function ()
{
  this.convertDT ();
  this.parseDT   ();
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.convertDT = function ()
{
  this.getSpecificDT ("sgd");
  this.getSpecificDT ("egd");
  this.getSpecificDT ("agd");
  this.getSpecificDT ("srd");
  this.getSpecificDT ("erd");
  this.getSpecificDT ("ard");

  this.getSpecificDT ("sga");
  this.getSpecificDT ("ega");
  this.getSpecificDT ("aga");
  this.getSpecificDT ("sra");
  this.getSpecificDT ("era");
  this.getSpecificDT ("ara");
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getSpecificDT = function (code)
{
  var info = this._newInfo[code];
  if (info != "")
  {
    this._newDT[code] = new DTUtil (info, code);
  }
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.parseDT = function ()
{
  this._flightDepartureDT    = this.findMostSignificantDT ("d");
  this._flightArrivalDT      = this.findMostSignificantDT ("a");
  
  this._scheduledDepartureDT = this.findScheduledDT       ("d");
  this._scheduledArrivalDT   = this.findScheduledDT       ("a");
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.findMostSignificantDT = function (postFix)
{
  var dt;

  var nag = this._newDT["ag" + postFix];
  var  ag = this._oldDT["ag" + postFix];
  var neg = this._newDT["eg" + postFix];
  var  eg = this._oldDT["eg" + postFix];

  var nar = this._newDT["ar" + postFix];
  var  ar = this._oldDT["ar" + postFix];
  var ner = this._newDT["er" + postFix];
  var  er = this._oldDT["er" + postFix];
  
  // Check for new actual gate 
  if ((nag != null) && (ag != null))
  {
    if (nag.getTime () != ag.getTime ())
    {
      return nag;
    }
  }
  
  // Check for new actual runway
  if ((nar != null) && (ar != null))
  {
    if (nar.getTime () != ar.getTime ())
    {
      return nar;
    }
  }
  
  if (nag != null)
  {
    return nag;
  }
  
  if (nar != null)
  {
    return nar;
  }
  
  // Check for new expected gate
  if ((neg != null) && (eg != null))
  {
    if (neg.getTime () != eg.getTime ())
    {
      return neg;
    }
  }
  
  // Check for new expected runway
  if ((ner != null) && (er != null))
  {
    if (ner.getTime () != er.getTime ())
    {
      return ner;
    }
  }
  
  if (neg != null)
  {
    return neg;
  }
  
  if (ner != null)
  {
    return ner;
  }
  
  return this.findScheduledDT (postFix);
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.findScheduledDT = function (postFix)
{
  var nsg = this._newDT["sg" + postFix];
  var  sg = this._oldDT["sg" + postFix];

  var nsr = this._newDT["sr" + postFix];
  var  sr = this._oldDT["sr" + postFix];
  
  // Check for new scheduled gate
  if ((nsg != null) && (sg != null))
  {
    if (nsg.getTime () != sg.getTime ())
    {
      return nsg;
    }
  }
  
  // Check for new scheduled runway
  if ((nsr != null) && (sr != null))
  {
    if (nsr.getTime () != sr.getTime ())
    {
      return nsr;
    }
  }
  
  if (nsg != null)
  {
    return nsg;
  }
  
  if (nsr != null)
  {
    return nsr;
  }
  
  return null;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getAirlineCode = function ()
{
  var str = this._newInfo["ac"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getAirlineName = function ()
{
  var str = this._newInfo["an"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getFlightNumber = function ()
{
  var str = this._newInfo["fn"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getMessage = function ()
{
  var str = this._newInfo["message"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.isTrackingEnabled = function ()
{
  var str = this._newInfo["te"];
  debug.trace (str);
  if ((str == null) || (str == "") || (str == "False"))
  {
    return false;
  }

  return true;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getDepartureAirportCode = function ()
{
  var str = this._newInfo["dac"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getArrivalAirportCode = function ()
{
  var str = this._newInfo["aac"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getDepartureAirportName = function ()
{
  var str = this._newInfo["dan"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getArrivalAirportName = function ()
{
  var str = this._newInfo["aan"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getDepartureAirportCity = function ()
{
  var str = this._newInfo["dat"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getArrivalAirportCity = function ()
{
  var str = this._newInfo["aat"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getDepartureTZ = function ()
{
  var str = this._newInfo["dtz"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getArrivalTZ = function ()
{
  var str = this._newInfo["atz"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getDepartureTerminal = function ()
{
  var str = this._newInfo["dt"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getArrivalTerminal = function ()
{
  var str = this._newInfo["at"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getDepartureGate = function ()
{
  var str = this._newInfo["dg"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getArrivalGate = function ()
{
  var str = this._newInfo["ag"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return str;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getFlightStatus = function ()
{
  var str = this._newInfo["st"];
  if ((str == null) || (str == ""))
  {
    return "";
  }

  return this._newInfo["st"].toUpperCase ();
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getScheduledDepartureDT = function ()
{
  return this._scheduledDepartureDT;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getScheduledArrivalDT = function ()
{
  return this._scheduledArrivalDT;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getFlightDepartureDT = function ()
{
  return this._flightDepartureDT;
}

///////////////////////////////////////////////////////////////////////////////
FlightInfo.prototype.getFlightArrivalDT = function ()
{
  return this._flightArrivalDT;
}


///////////////////////////////////////////////////////////////////////////////
// XML HTTP REQUEST
///////////////////////////////////////////////////////////////////////////////
var UPDATE_URL = "http://flightmonitor.kroonwijk.nl/getdata.php";
var g_xmlHttpRequest = null;
var g_flightInfo = new FlightInfo ();

///////////////////////////////////////////////////////////////////////////////
function SendUpdateRequest (forceUpdate)
{
  // Start to download the Google logo
  try
  {
    // Firefox, Opera 8.0+, Safari
    g_xmlHttpRequest = new XMLHttpRequest ();
  }
  catch (e)
  {
    // Internet Explorer
    try
    {
      g_xmlHttpRequest = new ActiveXObject ("Msxml2.XMLHTTP");
    }
    catch (e)
    {
      g_xmlHttpRequest = new ActiveXObject ("Microsoft.XMLHTTP");
    }
  }

  if (g_xmlHttpRequest == null)
  {
    debug.error ("Cannot create XMLHTTPRequest object");
    return;
  }

  var queryStr = "?type=GoogleDesktop&synd=gd&up_arrDep=D&lang=" + GADGET_LANGUAGE;
  queryStr += "&up_airlineCode="  + options.getValue ("airlineCode");
  queryStr += "&up_flightNumber=" + options.getValue ("flightNumber");
  queryStr += "&up_airportCode="  + options.getValue ("airportCode");
  queryStr += "&up_flightDate="   + options.getValue ("flightDate");
  
  if (forceUpdate)
  {
    queryStr += "&up_forceUpdate=magic";
  }
  
  debug.trace (UPDATE_URL + queryStr);

  try
  {
    g_xmlHttpRequest.open ("GET", UPDATE_URL + queryStr, true);
  }
  catch (e)
  {
    // Catch invalid URLs
    debug.error ("Error invalid url");
    g_xmlHttpRequest = null;
    return;
  }

  // Set the callback for when the downloading is completed (or failed)
  g_xmlHttpRequest.onreadystatechange = onStateChanged;

  // Start the download
  try
  {
    g_xmlHttpRequest.send ();
  }
  catch (e)
  {
    // Catch errors sending the request
    debug.error ("Error sending request");
    g_xmlHttpRequest = null;
    return;
  }
}

///////////////////////////////////////////////////////////////////////////////
function onStateChanged () 
{ 
  if (g_xmlHttpRequest.readyState != 4)
  {
    return;
  }

  var response = g_xmlHttpRequest.responseXML;
  
  if ((response == null) ||
      (typeof (response) != "object") || 
      (response.firstChild == null))
  {
    debug.error ("Error in response object");
    return;
  }

  g_flightInfo.update (response);
  
  UpdateContent ();
}


///////////////////////////////////////////////////////////////////////////////
// DYNAMIC CONTENT
///////////////////////////////////////////////////////////////////////////////
var rotRows_ = new Array ();

///////////////////////////////////////////////////////////////////////////////
function UpdateContent ()
{
  var showDeparture = options.getValue ("showDeparture");
  
  if (showDeparture)
  {
    departureButton.tooltip = GADGET_SHOW_ARRIVAL;
//    departureButton.overImage = "stock_images/arrival_button.png";
//    departureButton.downImage = "stock_images/arrival_button.png";
//    departureButton.image = "stock_images/arrival_button.png";
  }
  else
  {
    departureButton.tooltip = GADGET_SHOW_DEPARTURE;
//    departureButton.overImage = "stock_images/departure_button.png";
//    departureButton.downImage = "stock_images/departure_button.png";
//    departureButton.image = "stock_images/departure_button.png";
  }

  var caption = g_flightInfo.getAirlineCode ();
  caption += "-" + g_flightInfo.getFlightNumber ();
  caption += " " + GetFlightStatus (showDeparture);
  caption += " " + GetDetailHour () + ":" + GetDetailMin ();
  caption += " - " + GADGET_NAME;
  view.caption = caption;

  headerLabel .innerText = GetHeaderStr    (showDeparture);
  airportLabel.innerText = GetDirectionStr (showDeparture);

  rotRows_["airlineCode"]  .setStr (g_flightInfo.getAirlineCode  ());
  rotRows_["flightNumber"] .setStr (g_flightInfo.getFlightNumber ());
  
  rotRows_["airportName"]  .setStr (GetAirportName  (showDeparture));
  rotRows_["flightStatus"] .setStr (GetFlightStatus (showDeparture));

  rotRows_["expectedHour"] .setStr (GetDetailHour   (showDeparture));
  rotRows_["expectedMin"]  .setStr (GetDetailMin    (showDeparture));
  rotRows_["terminal"]     .setStr (GetTerminal     (showDeparture));
  rotRows_["gate"]         .setStr (GetGate         (showDeparture));

  headerLabel.href     = GetAirportLink    ( showDeparture);
  headerLabel.tooltip  = GetAirportTooltip ( showDeparture);

  airportLabel.href    = GetAirportLink    (!showDeparture);
  airportLabel.tooltip = GetAirportTooltip (!showDeparture);
  
  flightLabel.href     = GetFlightLink     (g_flightInfo.getAirlineCode (), g_flightInfo.getFlightNumber (), daEdit.value, ddEdit.value);
  flightLabel.tooltip  = GetFlightTooltip  ();

  var isTrackingEnabled = g_flightInfo.isTrackingEnabled ();
  trackButton.enabled   = isTrackingEnabled;
  trackLink.enabled     = isTrackingEnabled;
  
  if (isTrackingEnabled)
  {
    trackLink.tooltip = GADGET_TRACK_FLIGHT;
  }
  else
  {
    trackLink.tooltip = GADGET_TRACK_FLIGHT_DISABLED;
  }
  
  UpdateMessage   ();
  UpdateLocalTime ();
}

///////////////////////////////////////////////////////////////////////////////
function GetHeaderStr (showDeparture)
{
  var value;
  if (showDeparture)
  {
    value = g_flightInfo.getDepartureAirportCity ();
    if (value != "")
    {
      return value + " " + GADGET_DEPARTURE;
    }
    
    return GADGET_DEPARTURES;
  }
  else
  {
    value = g_flightInfo.getArrivalAirportCity ();
    if (value != "")
    {
      return value + " " + GADGET_ARRIVAL;
    }
    
    return GADGET_ARRIVALS;
  }
}

///////////////////////////////////////////////////////////////////////////////
function GetDirectionStr (showDeparture)
{
  if (showDeparture)
  {
    return GADGET_TO;
  }
  else
  {
    return GADGET_FROM;
  }
}

///////////////////////////////////////////////////////////////////////////////
function GetAirportName (showDeparture)
{
  if (showDeparture)
  {
    return g_flightInfo.getArrivalAirportCity   ();
  }
  else
  {
    return g_flightInfo.getDepartureAirportCity ();
  }
}

///////////////////////////////////////////////////////////////////////////////
function GetFlightStatus (showDeparture)
{
  var value = g_flightInfo.getFlightStatus ();

  if (value == "SCHEDULED")
  {
    return GADGET_SCHEDULED;
  }
  else if (value == "CANCELLED")
  {
    return GADGET_CANCELLED;
  }
  else if (value == "ACTIVE")
  {
    if (showDeparture)
    {
      return GADGET_DEPARTED;
    }
    else
    {
      return GADGET_EXPECTED;
    }
  }
  else if (value == "LANDED")
  {
    if (showDeparture)
    {
      return GADGET_DEPARTED;
    }
    else
    {
      return GADGET_LANDED;
    }
  }
  else
  {
    value = GADGET_UNKNOWN;
  }
  
  return value;
}

///////////////////////////////////////////////////////////////////////////////
function GetDetailHour (showDeparture)
{
  var dt = GetDetailDT (showDeparture);
  if (dt == null)
  {
    return "";
  }

  return dt.getFormattedHour ();
}

///////////////////////////////////////////////////////////////////////////////
function GetDetailMin (showDeparture)
{
  var dt = GetDetailDT (showDeparture);
  if (dt == null)
  {
    return "";
  }

  return dt.getFormattedMin ();
}

///////////////////////////////////////////////////////////////////////////////
function GetDetailDT (showDeparture)
{
  var dt;
  if (showDeparture)
  {
    dt = g_flightInfo.getFlightDepartureDT ();
  }
  else
  {
    dt = g_flightInfo.getFlightArrivalDT   ();
  }

  return dt;
}

///////////////////////////////////////////////////////////////////////////////
function GetTerminal (showDeparture)
{
  if (showDeparture)
  {
    return g_flightInfo.getDepartureTerminal ();
  }
  else
  {
    return g_flightInfo.getArrivalTerminal ();
  }
}

///////////////////////////////////////////////////////////////////////////////
function GetGate (showDeparture)
{
  if (showDeparture)
  {
    return g_flightInfo.getDepartureGate ();
  }
  else
  {
    return g_flightInfo.getArrivalGate ();
  }
}

///////////////////////////////////////////////////////////////////////////////
function GetAirportLink (showDeparture)
{
  var baseUrl = "http://flightmonitor.kroonwijk.nl/redir.php?up_action=airport_details";

  var value;
  if (showDeparture)
  {
    value = g_flightInfo.getDepartureAirportCode ();
    if (value != "")
    {
      return  baseUrl + "&up_airportCode=" + value;
    }
    
    return baseUrl;
  }
  else
  {
    value = g_flightInfo.getArrivalAirportCode ();
    if (value != "")
    {
       return  baseUrl + "&up_airportCode=" + value;
    }
    
    return baseUrl;
  }
}

///////////////////////////////////////////////////////////////////////////////
function GetAirportTooltip (showDeparture)
{
  var tooltip = "";
  
  var name;
  var code;
  
  if (showDeparture)
  {
    name = g_flightInfo.getDepartureAirportName ();
    code = g_flightInfo.getDepartureAirportCode ();
  }
  else
  {
    name = g_flightInfo.getArrivalAirportName ();
    code = g_flightInfo.getArrivalAirportCode ();
  }
  
  if (code != "")
  {
    tooltip += code + " - ";
  }
  
  if (name != "")
  {
    tooltip += name + " ";
  }
  
  tooltip += "(" + GADGET_FIND_AIRPORT_DETAILS + ")";
  return tooltip;
}

///////////////////////////////////////////////////////////////////////////////
function GetFlightLink (ac, fn, da, dd)
{
  var baseUrl = "http://flightmonitor.kroonwijk.nl/redir.php";

  var value = "?up_airlineCode="   + ac;
  value    += "&up_flightNumber="  + fn;
  value    += "&up_airportCode="   + da;
  value    += "&up_departureDate=" + dd;
  value    += "&up_action=flight_status";
    
  return baseUrl + value;
}

///////////////////////////////////////////////////////////////////////////////
function GetFlightTooltip ()
{
  var tooltip = "";
  
  var name   = g_flightInfo.getAirlineName  ();
  var code   = g_flightInfo.getAirlineCode  ();
  var number = g_flightInfo.getFlightNumber ();
  
  if (code != "")
  {
    tooltip += code + " - ";
  }
  
  if (name != "")
  {
    tooltip += name + " ";
  }
  
  if (number != "")
  {
    tooltip += number + " ";
  }
  
  tooltip += "(" + GADGET_FIND_FLIGHT_DETAILS + ")";
  return tooltip;
}

///////////////////////////////////////////////////////////////////////////////
function GetTrackerLink (ac, fn, da, dd)
{
  var baseUrl = "http://flightmonitor.kroonwijk.nl/redir.php";

  var value = "?up_airlineCode="   + ac;
  value    += "&up_flightNumber="  + fn;
  value    += "&up_airportCode="   + da;
  value    += "&up_departureDate=" + dd;
  value    += "&up_action=flight_tracker";
    
  return baseUrl + value;
}

///////////////////////////////////////////////////////////////////////////////
function GetScheduledDT (showDeparture)
{
  var dt;
  if (showDeparture)
  {
    dt = g_flightInfo.getScheduledDepartureDT ();
  }
  else
  {
    dt = g_flightInfo.getScheduledArrivalDT ();
  }

  return dt;

}

///////////////////////////////////////////////////////////////////////////////
function GetDT (showDeparture, showClock)
{
  var dt;
  if (showClock)
  {
    dt = GetLocalDT (showDeparture);
  }
  else
  {
    dt = GetScheduledDT (showDeparture);
  }

  return dt;
}

///////////////////////////////////////////////////////////////////////////////
function GetLocalDT (showDeparture)
{
  var now = new Date ();
  
  var e = now.getTime ();
  var f = now.getTimezoneOffset ();

  var tzOffset;
  if (showDeparture)
  {
    tzOffset = g_flightInfo.getDepartureTZ ();
  }
  else
  {
    tzOffset = g_flightInfo.getArrivalTZ ();
  }

  e += ((parseInt (tzOffset) * 60) + f) * 60 * 1000;
  now.setTime (e);

  var dt = new DTUtil (null, "now", now);
  return dt;
}

///////////////////////////////////////////////////////////////////////////////
function GetMonth (showDeparture, showClock)
{
  var dt = GetDT (showDeparture, showClock);
  if (dt == null)
  {
    return "";
  }

  return dt.getFormattedMonth ();
}

///////////////////////////////////////////////////////////////////////////////
function GetDay (showDeparture, showClock)
{
  var dt = GetDT (showDeparture, showClock);
  if (dt == null)
  {
    return "";
  }

  return dt.getFormattedDay ();
}

///////////////////////////////////////////////////////////////////////////////
function GetHour (showDeparture, showClock)
{
  var dt = GetDT (showDeparture, showClock);
  if (dt == null)
  {
    return "";
  }

  return dt.getFormattedHour ();
}

///////////////////////////////////////////////////////////////////////////////
function GetMin (showDeparture, showClock)
{
  var dt = GetDT (showDeparture, showClock);
  if (dt == null)
  {
    return "";
  }

  return dt.getFormattedMin ();
}

///////////////////////////////////////////////////////////////////////////////
function UpdateMessage ()
{
  var value = g_flightInfo.getMessage ();

  if (value == null)
  {
    if (messagePane.opacity == 255)
    {
      hideMessage ();
    }
    messageLabel.innerText = "";
  }
  else
  {
    var str = "";
    if (-1 != value.indexOf ("Specify an airline code"))
    {
      str += "- " + GADGET_SPECIFY_AIRLINE_CODE + "\n";
    }
    if (-1 != value.indexOf ("Specify a flight number"))
    {
      str += "- " + GADGET_SPECIFY_FLIGHT_NUMBER + "\n";
    }
    if (-1 != value.indexOf ("An airport must be provided"))
    {
      str += "- " + GADGET_SPECIFY_AIRPORT_CODE + "\n";
    }
    if (-1 != value.indexOf ("The airline code is invalid"))
    {
      str += "- " + GADGET_INVALID_AIRLINE_CODE + "\n";
    }
    if (-1 != value.indexOf ("The flight number is invalid"))
    {
      str += "- " + GADGET_INVALID_FLIGHT_NUMBER + "\n";
    }
    if (-1 != value.indexOf ("The airport is invalid"))
    {
      str += "- " + GADGET_INVALID_AIRPORT_CODE + "\n";
    }
    if (-1 != value.indexOf ("Flight not found on selected date"))
    {
      str += "- " + GADGET_FLIGHT_NOT_FOUND + "\n";
    }

    if (messageLabel.innerText != str)
    {
      debug.trace (messageLabel.innerText + "," + str);
      showMessage ();
    }

    messageLabel.innerText = str;
  }
}

///////////////////////////////////////////////////////////////////////////////
function UpdateLocalTime ()
{
  var showClock     = options.getValue ("showClock");
  var showDeparture = options.getValue ("showDeparture");

  if (showClock)
  {
    dateLabel.innerText = GADGET_LOCAL_TIME;
    clockButton.tooltip = GADGET_SHOW_SCHEDULED_TIME;
  }
  else
  {
    dateLabel.innerText = GADGET_SCHEDULED_TIME;
    clockButton.tooltip = GADGET_SHOW_LOCAL_TIME;
  }

  rotRows_["flightDay"]    .setStr (GetDay   (showDeparture, showClock));
  rotRows_["flightMonth"]  .setStr (GetMonth (showDeparture, showClock));
  rotRows_["scheduledHour"].setStr (GetHour  (showDeparture, showClock));
  rotRows_["scheduledMin"] .setStr (GetMin   (showDeparture, showClock));
}


///////////////////////////////////////////////////////////////////////////////
// VIEW ONOPEN HANDLER
///////////////////////////////////////////////////////////////////////////////
function view_onOpen ()
{
  rotRows_["airlineCode"]   = new RotRow ( 3, " 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ", flightPane  ,   5,  0, 12, 10, 11, -1, -2, "#010101", "#EEEEEE");
  rotRows_["flightNumber"]  = new RotRow ( 4, " 0123456789"                          , flightPane  ,  40,  0, 12, 10, 11, -1, -2, "#010101", "#EEEEEE");
  rotRows_["flightDay"]     = new RotRow ( 2, " 0123456789"                          , flightPane  ,  88,  0, 12, 10, 11, -1, -2, "#010101", "#EEEEEE");
  rotRows_["flightMonth"]   = new RotRow ( 3, " ABCDEFGHIJKLMNOPQRSTUVWXYZÄ"         , flightPane  , 112,  0, 12, 10, 11, -1, -2, "#010101", "#EEEEEE");
  rotRows_["scheduledHour"] = new RotRow ( 2, " 0123456789"                          , flightPane  , 148,  0, 12, 10, 11, -1, -2, "#010101", "#EEEEEE");
  rotRows_["scheduledMin"]  = new RotRow ( 2, " 0123456789"                          , flightPane  , 173,  0, 12, 10, 11, -1, -2, "#010101", "#EEEEEE");
  rotRows_["airportName"]   = new RotRow (12, " ABCDEFGHIJKLMNOPQRSTUVWXYZ"          , flightPane2 ,   5,  0, 12, 10, 11, -1, -2, "#010101", "#EEEEEE");
  rotRows_["flightStatus"]  = new RotRow (10, " ABCDEFGHIJKLMNOPQRSTUVWXYZ"          , statusPane  ,   5,  0, 22, 18, 24, -6, -6, "#010101", "#EEEEEE");
  rotRows_["expectedHour"]  = new RotRow ( 2, " 0123456789"                          , statusPane2 ,   5,  0, 29, 18, 24, -5, -3, "#010101", "#EEEEEE");
  rotRows_["expectedMin"]   = new RotRow ( 2, " 0123456789"                          , statusPane2 ,  51,  0, 29, 18, 24, -5, -3, "#010101", "#EEEEEE");
  rotRows_["terminal"]      = new RotRow ( 3, " 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ", terminalPane,  70,  0, 12, 10, 11, -1, -2, "#010101", "#EEEEEE");
  rotRows_["gate"]          = new RotRow ( 3, " 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ", gatePane    ,  70,  0, 12, 10, 11, -1, -2, "#010101", "#EEEEEE");

  setInterval ("SendUpdateRequest ()", 1000 * 60 * 5);
  setInterval ("UpdateLocalTime   ()", 1000);

  SendUpdateRequest ();
}

function onMouseOver1 ()
{
  beginAnimation (changeOpac1, 100, 255, 100);
}

function onMouseOut1 ()
{
  beginAnimation (changeOpac1, 255, 100, 100);
}

function onMouseOver2 ()
{
  beginAnimation (changeOpac2, 100, 255, 100);
}

function onMouseOut2 ()
{
  beginAnimation (changeOpac2, 255, 100, 100);
}

function onMouseOver5 ()
{
  beginAnimation (changeOpac5, 100, 255, 100);
}

function onMouseOut5 ()
{
  beginAnimation (changeOpac5, 255, 100, 100);
}

function onMouseOver6 ()
{
  beginAnimation (changeOpac6, 100, 255, 100);
}

function onMouseOut6 ()
{
  beginAnimation (changeOpac6, 255, 100, 100);
}

function onMouseOver7 ()
{
  beginAnimation (changeOpac7, 100, 255, 100);
}

function onMouseOut7 ()
{
  beginAnimation (changeOpac7, 255, 100, 100);
}

function onMouseOver8 ()
{
  beginAnimation (changeOpac8, 100, 255, 100);
}

function onMouseOut8 ()
{
  beginAnimation (changeOpac8, 255, 100, 100);
}

function changeOpac1 ()
{
  flightButton.opacity = event.value; 
}

function changeOpac2 ()
{
  optionsButton.opacity = event.value; 
}

function changeOpac3 ()
{
  displayPane.opacity = event.value; 
  headerPane.opacity  = event.value; 
}

function changeOpac4 ()
{
  messagePane.opacity = event.value; 
}

function changeOpac5 ()
{
  movieButton.opacity = event.value; 
}

function changeOpac6 ()
{
  clockButton.opacity = event.value; 
}

function changeOpac7 ()
{
  departureButton.opacity = event.value; 
}

function changeOpac8 ()
{
  trackButton.opacity = event.value; 
}


function onShowOptions ()
{
  acEdit.value = options.getValue ("airlineCode");
  acEdit.focus ();

  fnEdit.value = options.getValue ("flightNumber");
  daEdit.value = options.getValue ("airportCode");
  ddEdit.value = options.getValue ("flightDate");

  flightButton.enabled    = false;
  movieButton.enabled     = false;
  departureButton.enabled = false;
  clockButton.enabled     = false;
  displayPane.enabled     = false;
  headerPane.enabled      = false;

  onMouseOut1 ();
  beginAnimation (changeOpac3, 255, 100, 500);
  beginAnimation (moveOptions, 260,  20, 500);
}

function onAcceptOptions ()
{
  messageLabel.innerText = "";

  beginAnimation (changeOpac3, 100, 255, 500);
  beginAnimation (moveOptions,  20, 260, 500);

  options.putValue ("airlineCode" , acEdit.value);
  options.putValue ("flightNumber", fnEdit.value);
  options.putValue ("airportCode" , daEdit.value);
  options.putValue ("flightDate"  , ddEdit.value);
  
  flightButton.enabled    = true;
  movieButton.enabled     = true;
  departureButton.enabled = true;
  clockButton.enabled     = true;
  displayPane.enabled     = true;
  headerPane.enabled      = true;
  
  SendUpdateRequest ();
}

function onShowMovie ()
{
  rotRows_["airlineCode"]  .setStr ("");
  rotRows_["flightNumber"] .setStr ("");
  rotRows_["flightDay"]    .setStr ("");
  rotRows_["flightMonth"]  .setStr ("");
  rotRows_["scheduledHour"].setStr ("");
  rotRows_["scheduledMin"] .setStr ("");
  rotRows_["airportName"]  .setStr ("");
  rotRows_["flightStatus"] .setStr ("");
  rotRows_["expectedHour"] .setStr ("");
  rotRows_["expectedMin"]  .setStr ("");
  rotRows_["terminal"]     .setStr ("");
  rotRows_["gate"]         .setStr ("");

  SendUpdateRequest (true);
}

function onClickClock ()
{
  options.putValue ("showClock", !options.getValue ("showClock"));

  UpdateLocalTime ();
}

function onClickDeparture ()
{
  options.putValue ("showDeparture", !options.getValue ("showDeparture"));

  UpdateContent ();
}

function onFindFlight ()
{
  ffLink.href = GetFlightLink (acEdit.value, fnEdit.value, daEdit.value, ddEdit.value);
}

function onTrackFlight ()
{
  trackLink.href = GetTrackerLink (g_flightInfo.getAirlineCode (), g_flightInfo.getFlightNumber (), daEdit.value, ddEdit.value);
}

//change the opacity for different browsers 
function moveOptions ()
{
  optionsPane.x = event.value; 
}

function hideMessage ()
{
  beginAnimation (changeOpac4, 255,   0, 500);
  beginAnimation (changeOpac3, 100, 255, 500);
}

function showMessage ()
{
  beginAnimation (changeOpac4,   0, 255, 500);
  beginAnimation (changeOpac3, 255, 100, 500);
}

function keyPressAc ()
{
  debug.trace ("keyPressAc: " + event.keyCode);
  if (event.keyCode == 9)
  {
    event.returnValue = false;
    fnEdit.focus ();
  }
  else if (event.keyCode == 13)
  {
    event.returnValue = false;
    onAcceptOptions ();
  }
}

function keyPressFn ()
{
  debug.trace ("keyPressFn: " + event.keyCode);
  if (event.keyCode == 9)
  {
    event.returnValue = false;
    daEdit.focus ();
  }
  else if (event.keyCode == 13)
  {
    event.returnValue = false;
    onAcceptOptions ();
  }
}

function keyPressDa ()
{
  debug.trace ("keyPressDa: " + event.keyCode);
  if (event.keyCode == 9)
  {
    event.returnValue = false;
    ddEdit.focus ();
  }
  else if (event.keyCode == 13)
  {
    event.returnValue = false;
    onAcceptOptions ();
  }
}

function keyPressDd ()
{
  debug.trace ("keyPressDd: " + event.keyCode);
  if (event.keyCode == 9)
  {
    event.returnValue = false;
    acEdit.focus ();
  }
  else if (event.keyCode == 13)
  {
    event.returnValue = false;
    onAcceptOptions ();
  }
}
